<?php
/*
Plugin Name: Eazy CF Captcha
Plugin URI: http://wordpress.org/extend/plugins/eazy-cf-catpcha/
Description: Eazy C(omment)F(orm) Captcha adds a captcha with a mathematic exercise to the comment form, preventing bots to spam your comments.
Version: 1.0.1
Author: Tamás Kiss
Author URI: http://www.playwithpixels.de
License: GPL2
*/


/*  Copyright 2011  Tamás Kiss  (email : tamas@playwithpixels.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


define( 'DS', DIRECTORY_SEPARATOR );
define( 'EAZYCFC_FOLDER', 'eazy-cf-catpcha' );
define( 'EAZYCFC_PATH', dirname( __FILE__ ) );

require EAZYCFC_PATH . DS . 'helper.php';


if ( is_admin() ) {
  require EAZYCFC_PATH . DS . 'admin' . DS . 'eazycfc-admin.php';
  // admin setup
  add_action('admin_menu', 'eazycfc_admin_setup');
  
  // on plugin activate
  register_activation_hook( __FILE__, 'eazycfc_admin_activate' );
  // on plugin deactive
  register_deactivation_hook( __FILE, 'eazycfc_admin_deactivate' );
}

// translation
add_action( 'init', 'eazycfc_load_translation' );

// hook it up
add_action( 'init', 'eazycfc_start_session' );
add_filter( 'comment_form_field_comment', 'eazycfc_add_captcha_field', 999, 1 );
add_action( 'pre_comment_on_post', 'eazycfc_compare_captcha', 999, 1 );

// add some style
add_action( 'wp_head', 'eazycfc_styles' );


$eazycfc_session_var = 'eazycfc_captcha_result';

// start session, if session not available
function eazycfc_start_session() {
  if ( !session_id() )
    session_start();
}

// compare the input vs. the real results
function eazycfc_compare_captcha( $comment_post_ID ) {
  global $eazycfc_session_var;
  // registered users don't need to solve captcha
  if ( is_user_logged_in() )
    return $comment_post_ID;
  
  if( !isset( $_POST['eazycfc_captcha'] )
      || intval( trim( $_POST['eazycfc_captcha'] ) ) != $_SESSION[$eazycfc_session_var]
      || ( isset( $_POST['eazycfc_captcha_sol'] )
        && trim( $_POST['eazycfc_captcha_sol'] ) != '' ) )
    wp_die( __( 'Error: please solve the captcha.', 'eazycfc' ) );
  return $comment_post_ID;
}

// generate the exercise and add the captcha field to the comment form
function eazycfc_add_captcha_field( $comment_field ) {
  global $eazycfc_session_var;
  // registered users don't need to solve captcha
  if ( is_user_logged_in() )
    return $comment_field;
  
  $first_var = rand( 10, 90 );
  $second_var = rand( 0, 9 );
  $bot_var = rand( 1, 90 );
  $operator = ( rand( 0, 1 ) == 0 ) ? ' + ' : ' - ';
  $bot_operator = ( rand( 0, 1 ) == 0 ) ? ' + ' : ' - ';
  $exercise = $first_var . $operator . $second_var;
  $result = -1;
  eval('$result = ' . $exercise . ';');
  
  $_SESSION[$eazycfc_session_var] = $result;
  
  $vars['exercise'] = array(
    'var1' => $first_var,
    'operator' => $operator,
    'var2' => $second_var,
    'bot_var' => $bot_var,
    'bot_operator' => $bot_operator
  );
  
  $vars['label_text'] = get_option( 'eazycfc_label_text', '' );
  
  $captcha = eazycfc_render_file( 'captcha.php', $vars );
  
  $comment_field = $comment_field . $captcha;
  
  return $comment_field;
}


?>