<?php


function eazycfc_load_translation() {
  load_plugin_textdomain( 'eazycfc', '', EAZYCFC_FOLDER . DS . 'languages' );
}


function eazycfc_styles() {
  echo '
<style type="text/css">
  .eazycfc-hide { display: none; }
</style>
  ';
}


function eazycfc_render_file( $filename, $vars = array() ) {
  
  extract( $vars );
  
  ob_start();
  
  if ( file_exists( TEMPLATEPATH . DS . EAZYCFC_FOLDER . DS . $filename ) )
    include TEMPLATEPATH . DS . EAZYCFC_FOLDER . DS . $filename;
  else if ( file_exists(EAZYCFC_PATH . DS . 'views' . DS . $filename ) )
    include EAZYCFC_PATH . DS . 'views' . DS . $filename;
  else
    echo '<div class="error"><p>Rendering of file ' . $filename . ' failed.</p></div>';

  $render_result = ob_get_contents();
  ob_end_clean();
  
  return $render_result;
  
}


function eazycfc_render_admin_file( $filename, $vars = array() ) {
  if ( !is_admin() )
    return '';
  if ( !file_exists( EAZYCFC_PATH . DS . 'admin' . DS . 'views' . DS . $filename ) )
    return '<div id="message" class="error"><p>Rendering of file ' . $filename . ' failed.</p></div>';
  
  extract($vars);
  
  ob_start();

  include EAZYCFC_PATH . DS . 'admin' . DS . 'views' . DS . $filename;

  $render_result = ob_get_contents();
  ob_end_clean();
  
  return $render_result;
}

?>